=== debian/changelog ===
openclonk (6.1-1build1) wily; urgency=medium

  * No-change rebuild against libtinyxml2.6.2v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 04 Aug 2015 20:48:21 +0000

openclonk (6.1-1) unstable; urgency=medium

  * Imported Upstream version 6.1
  * Drop patches: all merged upstream.
  * debian/rules: Set USE_SYSTEM_TINYXML.
  * Enable parallel building.

 -- Philipp Kern <pkern@debian.org>  Sat, 13 Jun 2015 13:40:49 +0200

openclonk (6.0-1) unstable; urgency=medium

  * Imported Upstream version 6.0
  * Drop system tinyxml patch: applied upstream.
  * Build system: Check for SDL after defining the executable.
  * C4Shader.cpp: Do not interpret a buffer as a format string.

 -- Philipp Kern <pkern@debian.org>  Fri, 27 Mar 2015 11:06:17 +0100
