=== debian/control ===
Source: openclonk
Section: games
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Philipp Kern <pkern@debian.org>
Build-Depends: debhelper (>= 9), cmake (>= 2.8.4), libx11-dev, libxxf86vm-dev, libxrandr-dev, libxpm-dev, libglew-dev, libgl1-mesa-dev, libpng12-dev, libssl-dev, libsdl1.2-dev, libsdl-mixer1.2-dev, libgtk2.0-dev, libjpeg-dev, zlib1g-dev, libboost-dev, libupnp-dev, libfreetype6-dev, libboost-regex-dev, imagemagick, libtinyxml-dev
Standards-Version: 3.9.3
Homepage: http://www.openclonk.org
VCS-Git: git://git.0x539.de/git/users/pkern/openclonk-debian.git
VCS-Browser: http://git.0x539.de/?p=users/pkern/openclonk-debian.git;a=summary

Package: openclonk
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, openclonk-data (= ${source:Version})
Description: multiplayer game of strategy, action and skill
 OpenClonk is a free multiplayer action game where you control clonks,
 small but witty and nimble humanoid beings. The game is mainly about
 mining, settling and fast-paced melees. OpenClonk is also not just a
 game but also a versatile 2D game engine that offers countless
 possibilities to make own mods.
 .
 This package contains the OpenClonk engine.

Package: openclonk-data
Architecture: all
Depends: ${misc:Depends}
Recommends: openclonk
Description: multiplayer game of strategy, action and skill - data
 OpenClonk is a free multiplayer action game where you control clonks,
 small but witty and nimble humanoid beings. The game is mainly about
 mining, settling and fast-paced melees. OpenClonk is also not just a
 game but also a versatile 2D game engine that offers countless
 possibilities to make own mods.
 .
 This package contains the game data.

Package: openclonk-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends}, openclonk (= ${binary:Version})
Description: multiplayer game of strategy, action and skill - debug symbols
 OpenClonk is a free multiplayer action game where you control clonks,
 small but witty and nimble humanoid beings. The game is mainly about
 mining, settling and fast-paced melees. OpenClonk is also not just a
 game but also a versatile 2D game engine that offers countless
 possibilities to make own mods.
 .
 This package contains the debugging symbols. It is usually not needed.
