=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake -Bbuild --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DWITH_AUTOMATIC_UPDATE=0 -DUSE_STATIC_BOOST=OFF -DUSE_SYSTEM_TINYXML=ON

override_dh_strip:
	dh_strip --dbg-package=openclonk-dbg

override_dh_builddeb:
	dh_builddeb -- -Zxz

override_dh_auto_build-indep:
	convert -monitor src/res/oc32.png oc32.xpm
