=== debian/changelog ===
openclonk (7.0-4) unstable; urgency=medium

  * Add OpenClonk to the categories StrategyGame and ArcadeGame.
    (Closes: #825678)

 -- Philipp Kern <pkern@debian.org>  Tue, 04 Oct 2016 11:18:53 +0200

openclonk (7.0-3) unstable; urgency=medium

  * Ship Music.ocg's content unpacked.

 -- Philipp Kern <pkern@debian.org>  Sun, 14 Feb 2016 12:25:12 +0100

openclonk (7.0-2) unstable; urgency=medium

  * Build-depend on libglew-dev (>= 1.5.6)
  * Build-depend on libopenal-dev and libalut-dev.
  * Boost is no longer required (all c++14).
  * System TinyXML detection is now automatic.

 -- Philipp Kern <pkern@debian.org>  Sun, 17 Jan 2016 22:41:16 +0100

openclonk (7.0-1) unstable; urgency=medium

  * Imported Upstream version 7.0

 -- Philipp Kern <pkern@debian.org>  Sun, 17 Jan 2016 13:31:13 +0100

openclonk (6.1-2) unstable; urgency=medium

  * Rebuild against libpng-dev. (Closes: #810195)

 -- Philipp Kern <pkern@debian.org>  Thu, 07 Jan 2016 10:02:41 +0100
