=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: openclonk
 Section: games
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Philipp Kern <pkern@debian.org>
-Build-Depends: debhelper (>= 9), cmake (>= 2.8.4), libx11-dev, libxxf86vm-dev, libxrandr-dev, libxpm-dev, libglew-dev, libgl1-mesa-dev, libpng12-dev, libssl-dev, libsdl1.2-dev, libsdl-mixer1.2-dev, libgtk2.0-dev, libjpeg-dev, zlib1g-dev, libboost-dev, libupnp-dev, libfreetype6-dev, libboost-regex-dev, imagemagick, libtinyxml-dev
+Maintainer: Philipp Kern <pkern@debian.org>
+Build-Depends: debhelper (>= 9), cmake (>= 2.8.4), libx11-dev, libxxf86vm-dev, libxrandr-dev, libxpm-dev, libglew-dev (>= 1.5.6), libgl1-mesa-dev, libpng-dev, libssl-dev, libsdl1.2-dev, libsdl-mixer1.2-dev, libgtk-3-dev, libjpeg-dev, zlib1g-dev, libupnp-dev, libfreetype6-dev, libboost-regex-dev, imagemagick, libtinyxml-dev, libopenal-dev, libalut-dev
 Standards-Version: 3.9.3
 Homepage: http://www.openclonk.org
 VCS-Git: git://git.0x539.de/git/users/pkern/openclonk-debian.git
