=== debian/watch ===
version=3
http://www.openclonk.org/builds/release/([\d\.]+)/openclonk-([\d\.]+)-src.tar.bz2
